/*
 * Copyright (c) 2000-2002 Silicon Graphics, Inc and LANL  All Rights Reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as 
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it would be useful, but 
 * WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details. 
 *
 * You should have received a copy of the GNU General Public License along 
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston MA 02111-1307, USA.
 *
 * Contact information:  Silicon Graphics, Inc., 1600 Amphitheatre Pkwy, 
 * Mountain View, CA  94043, or:
 * 
 * http://www.sgi.com 
 */

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif	/* HAVE_CONFIG_H */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <malloc.h>
#include <sys/types.h>
#include <sys/param.h>
#include <unistd.h>
#include <errno.h>

#include "acctdef.h"
#include "sbu.h"
#include "acctmsg.h"

#define	FUNC_NAME	"init_mtask()"	/* library function name */

/*
 *	Initialize the multitasking CPU time SBU array.
 */
void
init_mtask()
{
	char	label[25];	/* label of config file variable */
	char	*resp;
	int	db_flag = 0;
	int	ind;
	int	size;

	/*
	 *	Get the SBUs associated with the number of CPUs.
	 */
	size = sizeof(struct mt_weights) * ACCT_MAXCPUS;
	if ((mttime_weight = (struct mt_weights *)malloc(size)) == NULL) {
		acct_perr(ACCT_ABORT, errno,
			_("%s: There was insufficient memory available when allocating '%s'."),
			FUNC_NAME,
			"multitasking SBUs");
	}

	for (ind = 0; ind < ACCT_MAXCPUS; ind++) {
		sprintf(label, "%s%d", MTTIME_WEIGHT, ind);
		mttime_weight[ind].cpu = init_real(label, 1.0, FALSE);

		if (db_flag >= 2) {
			Ndebug("mttime_weight[%d]:  cpu = %f\n",
				ind, mttime_weight[ind].cpu);
		}
	}

	return;
}
#undef	FUNC_NAME
